<script lang="ts" setup>
import { computed } from 'vue';
import type { RouteLocationRaw } from 'vue-router';

const props = withDefaults(
  defineProps<{
    href?: string;
    to?: RouteLocationRaw;
    type?:
      | 'default'
      | 'standalone'
      | 'cta'
      | 'primary'
      | 'secondary'
      | 'negative';
    icon?: string | null;
    iconPosition?: 'before' | 'after';
  }>(),
  {
    href: undefined,
    to: undefined,
    type: 'default',
    icon: null,
    iconPosition: 'after',
  }
);

const linkClass = computed(() => {
  const baseClass = 'ecl-link';
  const classes = [baseClass, `${baseClass}--${props.type}`];
  if (props.icon) {
    classes.push(
      `${baseClass}--icon`,
      `${baseClass}--icon-${props.iconPosition}`
    );
  }
  return classes;
});

const linkComponent = computed(() => (props.to ? 'router-link' : 'a'));
const linkAttributes = computed(() => ({
  class: linkClass.value,
  ...(props.to ? { to: props.to } : { href: props.href }),
}));
</script>

<template>
  <component :is="linkComponent" v-bind="linkAttributes">
    <span class="ecl-link__label">
      <slot></slot>
    </span>
    <span
      v-if="$slots.icon"
      class="ecl-icon ecl-icon--fluid ecl-link__icon"
      aria-hidden="true"
    >
      <slot name="icon" />
    </span>
  </component>
</template>

<style scoped lang="scss">
</style>
